<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.bam.cassandra.data.archive.ui.HiveScriptStoreClient" %>
<%@ page import="org.apache.poi.util.ArrayUtil" %>
<%@ page import="org.wso2.carbon.bam.cassandra.data.archive.ui.CassandraDataArchiveAdminClient" %>
<%@ page import="java.rmi.RemoteException" %>
<!--
~ Copyright (c) 2005-2014, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<fmt:bundle basename="org.wso2.carbon.bam.cassandra.data.archive.ui.i18n.Resources">
    <carbon:breadcrumb
            label="cassandra.data.archive"
            resourceBundle="org.wso2.carbon.bam.cassandra.data.archive.ui.i18n.Resources"
            topPage="true"
            request="<%=request%>"/>
    <script type="text/javascript">
        function deleteRow(name, msg) {
            CARBON.showConfirmationDialog(msg + "' " + name + " ' ?", function() {
                document.location.href = "delete_jobs.jsp?" + "scriptName=" + name;
            });
        }
    </script>
    <%
        String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        HiveScriptStoreClient storeClient = new HiveScriptStoreClient(cookie, serverURL, configContext);
        CassandraDataArchiveAdminClient adminClient = new CassandraDataArchiveAdminClient(
                cookie, serverURL, configContext, request.getLocale());
        String[] archivalScriptNames = null;
        String[] deletionScriptNames = null;

        try {
            archivalScriptNames = storeClient.getAllScriptNames("archival");
            deletionScriptNames = storeClient.getAllScriptNames("deletion");
        } catch (Exception e) {
    %>
    <script type="text/javascript">
        CARBON.showErrorDialog("Error while getting the list of scripts");
    </script>
    <%
        }
    %>
    <div id="middle">
        <h2>Scheduled Jobs</h2>

        <div id="workArea">

                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th style="width:200px"><span style="float: left; position: relative; margin-top: 2px;">
                            <fmt:message key="archival.jobs"/></span>
                        </th>
                        <th>Actions</th>
                    </tr>
                    </thead>
                    <tbody>

                    <% if (null != archivalScriptNames) {
                        for (String aName : archivalScriptNames) {
                            String streamName = "";
                            String version =  "";
                            String numberOfDays =  "";
                            String cronExpression =  "";
                            String isDeletion =  "";
                            try {
                            streamName = adminClient.getJobProperty(aName,"StreamName");
                            version =  adminClient.getJobProperty(aName,"Version");
                            numberOfDays =  adminClient.getJobProperty(aName,"NumberOfDays");
                            cronExpression =  adminClient.getJobProperty(aName,"Cron");
                            isDeletion =  adminClient.getJobProperty(aName,"IsDeletion");
                            } catch (RemoteException e) {
                                e.printStackTrace();
                            }
                    %>
                    <tr>
                        <td><label>
                            <%=aName%>
                        </label>
                        </td>
                        <td>
                            <a class="icon-link" style="background: url('images/edit.gif') no-repeat;"
                               href="configure_archive_ui.jsp?stream_name=<%=streamName%>&version=<%=version%>&specified_date=<%=numberOfDays%>&cron=<%=cronExpression%>&archivalOrDeletion=<%=isDeletion.equals("true")?"deletion":"archival"%>">Edit</a>
                            <a onclick="deleteRow('<%=aName%>','Do you want to delete')"
                               class="delete-icon-link" href="#">Delete</a>
                        </td>

                    </tr>
                    <%
                        }
                    } else { %>
                    <tr>
                        <td colspan="2">No scripts found.</td>
                    </tr>

                    <% }
                    %>
                    </tbody>
                    <input type="hidden" id="driver" name="driver" value="">
                </table>

            <br>

            <table class="styledLeft">
                <thead>
                <tr>
                    <th style="width:200px"><span style="float: left; position: relative; margin-top: 2px;">
                            <fmt:message key="deletion.jobs"/></span>
                    </th>
                    <th>Actions</th>
                </tr>
                </thead>
                <tbody>

                <% if (null != deletionScriptNames) {
                    for (String aName : deletionScriptNames) {
                        String streamName = "";
                        String version =  "";
                        String numberOfDays =  "";
                        String cronExpression =  "";
                        String isDeletion =  "";
                        try {
                            streamName = adminClient.getJobProperty(aName,"StreamName");
                            version =  adminClient.getJobProperty(aName,"Version");
                            numberOfDays =  adminClient.getJobProperty(aName,"NumberOfDays");
                            cronExpression =  adminClient.getJobProperty(aName,"Cron");
                            isDeletion =  adminClient.getJobProperty(aName,"IsDeletion");
                        } catch (RemoteException e) {
                            e.printStackTrace();
                        }
                %>
                <tr>
                    <td><label>
                        <%=aName%>
                    </label>
                    </td>
                    <td>
                        <a class="icon-link" style="background: url('images/edit.gif') no-repeat;"
                           href="configure_archive_ui.jsp?stream_name=<%=streamName%>&version=<%=version%>&specified_date=<%=numberOfDays%>&cron=<%=cronExpression%>&archivalOrDeletion=<%=isDeletion.equals("true")?"deletion":"archival"%>">Edit</a>
                        <a onclick="deleteRow('<%=aName%>','Do you want to delete')"
                           class="delete-icon-link" href="#">Delete</a>
                    </td>

                </tr>
                <%
                    }
                } else { %>
                <tr>
                    <td colspan="2">No scripts found.</td>
                </tr>

                <% }
                %>
                </tbody>
            </table>

        </div>
    </div>


</fmt:bundle>